
/****  : <<      >>

  :C ; :Borland C.
  Memory model: Compact
---------------------------------------------------------------*/

#include <dos.h>      /* FP_SEG,FP_OFF,MK_FP,int86,REGS        */
#include <stdio.h>    /* fgetchar, printf,EOF                  */
#include <conio.h>    /* wherex, wherey, gotoxy, cprintf       */
#include <alloc.h>    /* farmalloc, farrealloc, coreleft       */
#include <stdlib.h>   /* exit                                  */

/***  INP ----------------------------------------------------
	      
	 far    
-------------------------------------------------------------------*/
#define INC( p1 )                                           \
	if ( FP_OFF(p1) == 0xffff )                         \
	 {                                                  \
	    p1 = MK_FP( FP_SEG(p1)+0x1000, FP_OFF(p1) );    \
	 }                                                  \
	 p1++;    bytes++;


#define NORMAL  0x07   /*   /      */
#define INVERS  0x70   /*   /      */
#define WAIT    0      /*              */
#define EXIT    1

#define SP  	  0x20
#define LF  	  0x0a
#define CR  	  0x0d
#define TAB 	  0x09
#define MARK_EOL  0x04
#define ESC       0x1b

typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;

/*   :                                    */

char *info_bar ="   <ENTER> Next Line      <SPASE> Next Screen          <ESC> Exit               ";
char *empty_bar="                                                                                ";
char far *p, *p1;     /*             */
uchar csym = 0;       /*                  */
uchar sheight;        /*                   */
uchar lline;          /*    ;             */
ulong bytes = 0;      /*          */
ulong wholeStream;    /*               */

/***  _XY --------------------------------------------------
	      . 
	BIOS  02H  INT 010h.
 :  x - ;
	y - ;
 : ;
--------------------------------------------------------------------*/
void to_xy( uchar x, uchar y )
{
	  asm mov ah, 02h;  /*  02h                   */
	  asm mov bh, 0;    /* 0 -              */
	  asm mov dh, y;    /*                            */
	  asm mov dl, x;    /*                         */
	  asm int 010h ;    /*  INT 010h            */
}

/***  HOW_LINES ----------------------------------------------
              sheight,
            lline.
  : -;
 : -;
---------------------------------------------------------------------*/
void how_lines()
{
   uchar y,x;

   y = wherey(); x = wherex();
   gotoxy(1,50);
   if ( wherey() == 50 ) sheight = 50;
   else { gotoxy(1,43);
	    if ( wherey() == 43 ) sheight = 43;
		 else sheight = 25; }

  lline = sheight - 1;
  gotoxy( x, y );
};

/***  SCROLL ---------------------------------------------------
            . BIOS, INT010h
        06H
 : nlines   -    ;
		   nlines = 0   ;
       lst_line -   ()   ;
 : -;
 ---------------------------------------------------------------------*/

void scroll( uchar nlines, uchar lst_line )
{
   union REGS Register;

   Register.h.ah = 0x06;       /*   BIOS                     */
   Register.h.al = nlines;     /*             */
   Register.h.ch = 0;          /*                   */
   Register.h.cl = 0;          /*                */
   Register.h.dh = lst_line;   /*                 */
   Register.h.dl = 79;         /*              */
   Register.h.bh = NORMAL;     /*             */

   int86( 0x10, &Register,&Register );

}

/***  SHOW_BOTTOM ----------------------------------------------
	       .
  : *line_25 -     ;
	attr     -    ;
 : -;
----------------------------------------------------------------------*/
void show_bottom( char *line_25, uchar attr )
{
   uint buff_off, buff_seg;

   buff_seg = FP_SEG( line_25 );/*     */
   buff_off = FP_OFF( line_25 );/*            */
				/*       */

   asm  mov bh,0;        /* 0                  */
   asm  mov bl,attr;     /*              */
   asm  mov cx,79;       /*  79                */
   asm  mov dh,lline;    /*                    */
   asm  mov dl,0;        /*                   */
   asm  mov ax,buff_seg; /*                                 */
   asm  mov es,ax;       /* S :             */
   asm  mov ah,013h;     /*  013h                    */
   asm  mov al,0;        /*   BL, .*/
   asm  push bp;         /*          */
   asm  mov bp,buff_off; /* BP :          */

   asm  int 010h;

   asm pop bp;           /*     */

}

/***  OUT_BUFF -----------------------------------------
	    .
  : lines -     ;
 : EXIT    ;
	WAIT   ;
--------------------------------------------------------------*/
uchar out_buff( uchar lines )
 {
   uchar cp,nlines = 0;
   uchar seol;  /*                     */
   uchar c=0;   /*                     */

 /*          (EOF) */
    while( (nlines != lines) && (*p1 != EOF) )
	{                                    //*p == MARK_EOL)
	  cp = *p1;
	  seol =  (*p1 == LF) || (c++==79) ;
	  nlines += ( seol ) ? 1 : 0;
	  asm mov ah,0eh;   /*  0h  BIOS          */
	  asm mov al,cp ;   /*   	    */
	  asm int 010h;
	  if ( seol ) c = 0;
	  INC ( p1 );
	}

   return ( *p1 == EOF ) ? EXIT : WAIT;
 }

/***  WAITKEY ------------------------------------------------
	      .
 : -;
:   , 0    ;
--------------------------------------------------------------------*/
char waitkey()
{
  union REGS Register;

  Register.h.ah = 0;                   /*  0h int016h   */

  int86( 0x16, &Register, &Register );
				       /*     AL */
  return ( Register.h.al>1 ) ? Register.h.al : 0;
}

/***  SHOWSCREEN ---------------------------------------------
         OUT_BUFF  
     .
  : -;
 :     OUT_BUFF(WAIT  EXIT).
--------------------------------------------------------------------*/
uchar showscreen()
{
	scroll( 0, lline-1 );   /*   ( info ) */
	to_xy ( 0, 0 );         /*   0,0                   */
 return out_buff( sheight-1 );  /*                */
}

/***  SHOWROW ------------------------------------------------
         OUT_BUFF  
     .
  : -;
 :     OUT_BUFF(WAIT  EXIT).
--------------------------------------------------------------------*/

uchar showrow()
{
	scroll( 1, lline-1 ); /*              */
	to_xy ( 0, lline-1 ); /*           */
 return out_buff( 1 );        /* 1                       */
}

/***    PUT  -------------------------------------------------
	      
	   ;
   : sym -     ;
  : -;
--------------------------------------------------------------------*/
void put( uchar sym )
{

   if ( csym >= 79 )   /*     */
    {
      char next_ch;

      csym = 0;
      if ( sym == LF ) { *p1 = LF; INC( p1 );
			  return;  }

      next_ch = fgetchar();
      if ( (next_ch == LF) || (next_ch == TAB) )
	    { *p1 = sym;INC( p1 );
	      return; }

	else {  *p1 = MARK_EOL;INC( p1 );
		*p1 = sym;     INC( p1 ); csym++;
		*p1 = next_ch; INC( p1 ); csym++;
		return;  }
   }

   if ( sym == LF )   {  csym = 0;            /*   LF  CR */
			 *p1 = CR; INC( p1 );
			 *p1 = LF; INC( p1 );
			 return;    }

  csym++;
 *p1 = sym;
 INC( p1 );

 return;
}

/***  SHOW_PROGRES ---------------------------------------------
                  
       .
-----------------------------------------------------------------------*/
void show_progress()
{
   to_xy( 70, lline );
   cprintf(" %d %%",bytes*100/wholeStream);
}

/***   
								 */
void main()
{
 char ch;                /*                 */
 char key;               /*       */
 ulong heap;             /*                         */
 int  _do;               /*            */
			 /* 			      */
  uchar c;               /*                                 */

 /*     ? */
    heap = coreleft();

 /*  .        */
  if ((p = (char *) farmalloc( heap )) == NULL)
       {
	 printf("    !\n");
	 exit(1);  /*     */
	}

  /*                         */

   p1 = p;   /* p1 -            */

   while ( (ch!=EOF) && (bytes<heap) ) {

	ch = fgetchar();

	if ( ch == TAB )
	   {
	       if (csym == 79) { *p1 = MARK_EOL;INC( p1 );
				 *p1 = fgetchar();INC(p1);
				 csym = 0; }
		else {
			uchar sps;
			sps = ( csym< 71  ) ? 8 : 79-csym;
			for ( c = 0; c<sps; c++)
				put( SP ); }
	   }
	else put( ch );

     } /* end while for input chars */

 /*  a                    */
   if ( bytes>=heap ) {
	printf("   !\n    !\n");
	exit(1); }

 /*    			*/
    farrealloc( p,bytes );

/*     ( )    */
/*      sheight  lline               */
  how_lines();

  wholeStream = bytes;
  bytes = 0;

  p1 = p;
 /*           */
  _do = showscreen();

  if ( _do == WAIT )  show_bottom( info_bar, INVERS );

  while( _do == WAIT )
   {
    show_progress();

    key = waitkey () ;

    switch ( key ) {
     case SP  :  _do = showscreen();break;
     case CR  :  _do = showrow();break;
     case ESC :  _do = EXIT; break;
     default  :  _do = WAIT;
     };
   }

  /*         */
     farfree( p );

to_xy( 0, lline-1 );
show_bottom( empty_bar, NORMAL );

}
